import { type Startable } from '@libp2p/interfaces/startable';
import type { AddressManager } from '@libp2p/interface-address-manager';
import type { ConnectionProtector } from '@libp2p/interface-connection';
import type { ConnectionGater } from '@libp2p/interface-connection-gater';
import type { ConnectionManager } from '@libp2p/interface-connection-manager';
import type { ContentRouting } from '@libp2p/interface-content-routing';
import type { Libp2pEvents } from '@libp2p/interface-libp2p';
import type { Metrics } from '@libp2p/interface-metrics';
import type { PeerId } from '@libp2p/interface-peer-id';
import type { PeerRouting } from '@libp2p/interface-peer-routing';
import type { PeerStore } from '@libp2p/interface-peer-store';
import type { Registrar } from '@libp2p/interface-registrar';
import type { TransportManager, Upgrader } from '@libp2p/interface-transport';
import type { EventEmitter } from '@libp2p/interfaces/events';
import type { Datastore } from 'interface-datastore';
export interface Components extends Record<string, any>, Startable {
    peerId: PeerId;
    events: EventEmitter<Libp2pEvents>;
    addressManager: AddressManager;
    peerStore: PeerStore;
    upgrader: Upgrader;
    registrar: Registrar;
    connectionManager: ConnectionManager;
    transportManager: TransportManager;
    connectionGater: ConnectionGater;
    contentRouting: ContentRouting;
    peerRouting: PeerRouting;
    datastore: Datastore;
    connectionProtector?: ConnectionProtector;
    metrics?: Metrics;
}
export interface ComponentsInit {
    peerId?: PeerId;
    events?: EventEmitter<Libp2pEvents>;
    addressManager?: AddressManager;
    peerStore?: PeerStore;
    upgrader?: Upgrader;
    metrics?: Metrics;
    registrar?: Registrar;
    connectionManager?: ConnectionManager;
    transportManager?: TransportManager;
    connectionGater?: ConnectionGater;
    contentRouting?: ContentRouting;
    peerRouting?: PeerRouting;
    datastore?: Datastore;
    connectionProtector?: ConnectionProtector;
}
export declare function defaultComponents(init?: ComponentsInit): Components;
//# sourceMappingURL=components.d.ts.map